<!-- begin jsp\common\system\runreport.jsp. -->
<%-- 
*********************************************************************************************************
Name: runreport.jsp

This page retrieves username, password, application name, current / selected query, web / report server
from the session and put them into hidden inputs which get posted to mroindex.asp on the report server.
This page is submitted only when the run reports action is performed and is not viewedable by the user.

Copyright 2001 MRO Software, Inc.
*********************************************************************************************************
--%>

<%@ page buffer="64kb" autoFlush="false" errorPage="../../common/system/error.jsp"
import= "psdi.jsp.beans.* , psdi.jsp.common.* , psdi.jsp.util.* , psdi.mbo.* , psdi.util.*, psdi.app.report.*, psdi.security.*, psdi.jsp.common.ecatalog.*, java.util.*" %>


<%@ include file="actuatefolder.jsp" %>

<%

MXSession MXsession = (MXSession)session.getValue("MXSession");
ReportServiceRemote reportService = (ReportServiceRemote)MXsession.lookup("REPORT");
String[] names = reportService.getReportServer();
String reportServer = names[0];
String adminPass = CipherPlusBase64.encrypt(names[1], "berns");
String smtpHost = names[2];
String connectString = names[3];
String mroRepName = "";
String test = "";
String mroReport = "";
String mroApp = "";
String schema = "";
String pageType = (String)session.getValue("page");

if(pageType == null)
{
	pageType = "";
}

if (smtpHost == null)
{
	smtpHost = "no";
}


String reportURL = "mroindex.jsp";	
UserInfo u = MXsession.getUserInfo();
schema = u.getSchemaOwner();
String mroSite = u.getSite();
String mroOrg = u.getOrganization();
String mroGroup = u.getUserGroup();
String laborcode = u.getLaborCode();
MboSetRemote laborSet = MXsession.getMboSet("LABOR");
laborSet.setQbeExactMatch(true);
laborSet.setQbe("laborcode", laborcode);
MboRemote labor = laborSet.moveNext();
String fromEmail = "";
if (labor == null) {
	fromEmail = "maximouser@maximouser.com";
} else {
	fromEmail = labor.getString("pagepin");
}
String mroSel = "1=1";
String mroCurr = "1=1";		
String mroCurrent = (String)session.getValue("mroCurrent");
String tableName = "";
String originalAppName = "";
String reportChange = "";
String testForSelect = "false";
String testForCurrent = "false";
if(mroCurrent == null || mroCurrent == "")
{
	mroCurrent = "1=1";
}

String mroSelect = (String)session.getValue("mroSelect");

if(mroSelect == null || mroSelect == "")
{
	mroSelect = "1=1";
}

if ((mroSelect.indexOf("select") > -1) || (mroSelect.indexOf("SELECT") > -1)) {
	testForSelect = "true";
}
if ((mroCurrent.indexOf("select") > -1) || (mroCurrent.indexOf("SELECT") > -1)) {
	testForCurrent = "true";
}


mroApp = (String)session.getValue("mroApp");

if(mroApp == null || mroApp.equals("STARTCENTERS"))
{
	mroApp = "";
}
String userName = MXsession.getUserName();
String password = CipherPlusBase64.encrypt(MXsession.getPassword(), "berns");


String mroOverview = (String)session.getValue("mroOverview");

if (fromEmail == null)
{
	fromEmail = "no";
}
String tempReportApp = "";
if (mroApp != "")
{
	// START: Get the main tablename of the app
	MboSetRemote appSet = MXsession.getMboSet("MAXAPPS");
	SqlFormat mroSqlFormat = new SqlFormat(u, "app = :1" ); 
	mroSqlFormat.setObject(1, "maxapps" , "app" , mroApp); 
	appSet.setWhere(mroSqlFormat.format()); 
	
	tempReportApp = mroApp;
	
	if (!appSet.isEmpty()) 
	originalAppName = appSet.getMbo(0).getString( "originalapp" ); 
	reportChange = appSet.getMbo(0).getString( "custapptype" ); 
	// END: Get the main tablename of the app
	if (originalAppName != null && originalAppName != "") {
		mroApp = originalAppName;
	}

	mroReport = (String)session.getValue("mroReport");
	if (mroReport.equals("detail"))
	{
		
		if (mroApp.equals("WOTRACK"))
		{
			test = "yes";
			mroRepName = "woprint";
		}
		else if (mroApp.equals("PO"))
		{
			mroRepName = "poprint";
		}
		else if (mroApp.equals("PR"))
		{
			mroRepName = "prprint";
		}
		else if (mroApp.equals("RFQ"))
		{
			mroRepName = "rfqprint";
		}
		else if (mroApp.equals("INVOICE"))
		{
			mroRepName = "invprint";
		}
		else if (mroApp.equals("QUICKREP"))
		{
			mroRepName = "woprint";
		}
		else if (mroApp.equals("WOREQ"))
		{
			mroRepName = "woprint";
		}
		else if (mroApp.equals("BUYER"))
		{
			mroRepName = "mrprint";
		}
		if ((originalAppName != null && originalAppName != "") && (reportChange.equals("1") || reportChange.equals("3"))) {
			mroRepName = tempReportApp + "print";
		}
	}
	else if(mroReport.equals("overview"))
	{
		if ((originalAppName != null && originalAppName != "") && (reportChange.equals("2") || reportChange.equals("3"))) {
			mroRepName = tempReportApp;
		} else {
			mroRepName = mroApp;
		}
	}
	else
	{
		mroRepName = "";
		
	}
	if (mroApp.equals("WOTRACK"))
	{
		tableName = "workorder";
	}
	else if (mroApp.equals("PO"))
	{
		tableName = "po";
	}
	else if (mroApp.equals("PR"))
	{
		tableName = "pr";
	}
	else if (mroApp.equals("PM"))
	{
		tableName = "pm";
	}
	else if (mroApp.equals("RFQ"))
	{
		tableName = "rfq";
	}
	else if (mroApp.equals("INVOICE"))
	{
		tableName = "invoice";
	}
	else if (mroApp.equals("QUICKREP"))
	{
		tableName = "workorder";
	}
	else if (mroApp.equals("WOREQ"))
	{
		tableName = "workorder";
	}
	else if (mroApp.equals("BUYER"))
	{
		tableName = "mr";
	}	
	else if (mroApp.equals("INVENTOR"))
	{
		tableName = "inventory";
	}
	else if (mroApp.equals("EQUIPMNT"))
	{
		tableName = "equipment";
	}
	else if (mroApp.equals("COND"))
	{
		tableName = "measurepoint";
	}
	else if (mroApp.equals("FAILURE"))
	{
		tableName = "failurelist";
	}
	else if (mroApp.equals("SERV"))
	{
		tableName = "servicecontract";
	}
	else if (mroApp.equals("ROUTES"))
	{
		tableName = "routes";
	}
	else if (mroApp.equals("SAFEPLAN"))
	{
		tableName = "safetyplan";
	}
	else if (mroApp.equals("PRECAUTN"))
	{
		tableName = "precaution";
	}
	else if (mroApp.equals("COMPANY"))
	{
		tableName = "companies";
	}
	else if (mroApp.equals("TOOL"))
	{
		tableName = "tool";
	}
	else if (mroApp.equals("LABOR"))
	{
		tableName = "labor";
	}
	else if (mroApp.equals("LOCATION"))
	{
		tableName = "locations";
	}
	else if (mroApp.equals("ASSIGNQU"))
	{
		tableName = "woassignmntqueue";
	}
	else if (mroApp.equals("HAZARDS"))
	{
		tableName = "hazard";
	}
	else if (mroApp.equals("CRAFT"))
	{
		tableName = "labor";
	}
	else if (mroApp.equals("ITEM"))
	{
		tableName = "item";
	}
	else if (mroApp.equals("JOBPLAN"))
	{
		tableName = "jobplan";
	}
	else if (mroApp.equals("RECEIPTS"))
	{
		tableName = "po";
	}
	else if (mroApp.equals("STOREROOM"))
	{
		tableName = "locations";
	}
	else if (mroApp.equals("TAGLOCKS"))
	{
		tableName = "tagout";
	}
}
String reqApp = request.getParameter("mroApp");
if (reqApp == null)
{
	reqApp = "";
}

String reqRepName = request.getParameter("mroRepName");
if (reqRepName == null)
{
	reqRepName = "";
}

if(reqApp != "")
{
	mroApp = reqApp;
	if(reqRepName.equals(""))
	{
		mroReport = "report";
	}
	else
	{
		mroRepName = reqRepName;
		mroReport = "detail";
	}
}

int k = 0;
String j = "\\\"";
int i = 0;
int m = mroCurrent.lastIndexOf('\"');
String n = mroCurrent.substring(m+1);
Vector v = new Vector();
do
{
	if (( i = mroCurrent.indexOf("\"",k)) > -1)
	{
		String d = mroCurrent.substring(k,i);
		String e = d + j;
		v.addElement(e);
		k = i + 1;
	}
	
} while(i!=-1);

mroCurrent = "";

for (int p=0; p<v.size(); p++)
{
	mroCurrent = mroCurrent + v.elementAt(p);	
}

mroCurrent = mroCurrent + n;


int r = mroSelect.lastIndexOf('\"');
String s = mroSelect.substring(r+1);
Vector w = new Vector();
k=0;
i=0;
String d=null;
String e=null;

do
{
	if (( i = mroSelect.indexOf("\"",k)) > -1)
	{
		d = mroSelect.substring(k,i);
		e = d + j;
		w.addElement(e);
		k = i + 1;
	}
} while(i!=-1);

mroSelect = "";

for (int p=0; p<v.size(); p++)
{
	mroSelect = mroSelect + w.elementAt(p);	
}

mroSelect = mroSelect + s;

// Find the variable that represents Yes
MboSetRemote varSet = MXsession.getMboSet("MAXVARS");
varSet.setQbe("varname", "YES");
MboRemote varYes = varSet.moveNext();
String yesValue = varYes.getString("varvalue");

// Get the attributes (db fields) in the application main table
MboSetRemote attrSet = MXsession.getMboSet("MAXSYSCOLUMNS2");
SqlFormat mroSqlFormat = new SqlFormat(u, "tbname = :1 and persistent = :2" ); 
mroSqlFormat.setObject(1, "maxsyscolumns2" , "tbname" , tableName); 
mroSqlFormat.setObject(2, "maxsyscolumns2" , "persistent" , yesValue); 
attrSet.setWhere(mroSqlFormat.format()); 

if (!attrSet.isEmpty()) 
{
	String[] appAttr = new String[attrSet.count()];
	for (i = 0; i < attrSet.count(); i++) {
		// Create array of attributes
		// Looks like this will come back uppercase even in sqlserver
		appAttr[i] = attrSet.getMbo(i).getString( "name" ).toLowerCase();
	}

	try
	{
		if (!mroSelect.equals("1=1"))
		{	
			// Remove subqueries from mroSelect
			StringBuffer whereBuffer = new StringBuffer(" " + mroSelect + " ");
			Vector subquery = new Vector(3);
			int beginSub = whereBuffer.toString().toLowerCase().indexOf("(select");
			int endSub = 0;
			int subCount = 0;
			String subPlaceholder = "xxxSubqueryGoesHerexxx";
			while (beginSub > -1) 
			{
				i = beginSub;	
				int parenCount = 1;
				do {	
					char c = whereBuffer.charAt(++i);
					if ( c == '(') {
						parenCount++;
					} else if ( c == ')') {
						parenCount--;
					}			
				} while (parenCount != 0);
				endSub = i;
				subquery.insertElementAt(whereBuffer.substring(beginSub, endSub+1), subCount);
				whereBuffer.replace(beginSub, endSub+1,  subPlaceholder);
				beginSub = whereBuffer.toString().toLowerCase().indexOf("(select");			
				subCount++;
			}
			// Split where clause into array; alternate between SQL and string literals	
			StringTokenizer stWhere = new StringTokenizer(whereBuffer.toString(), "'");
			String[] splitWhere = new String[stWhere.countTokens()];
			i = 0;

			while (stWhere.hasMoreTokens()) {
				splitWhere[i++] = stWhere.nextToken();			
			}

			StringBuffer whereFragment;
			int attrIdx = -1;
			// For each segment of mroSelect that is SQL (not literal), search for each attribute
			for(i=0; i<splitWhere.length; i++)
			{
				for(k=0; k<appAttr.length; k++)
				{
					whereFragment = new StringBuffer(splitWhere[i]);
					attrIdx = whereFragment.toString().toLowerCase().indexOf(appAttr[k]);

					while (attrIdx > -1) 
					{
						// Attribute has been found; determine if it is a valid field match 
						char priorChar = whereFragment.charAt(attrIdx-1);
						char nextChar = whereFragment.charAt(attrIdx + appAttr[k].length());

						// If preceeded by period, doesn't matter if this is our string or not
						// because this field is already qualified
						if (priorChar != '.') {
							if ((priorChar == ' ' || priorChar == '(') && (nextChar == ' ' || nextChar == '<' 
							|| nextChar == '>' || nextChar == '=' || nextChar == ')')) {
								// This is a valid match and is not qualified with the table name; insert it
								whereFragment.insert(attrIdx, tableName + ".");
								// Move index to after field name (adjust for inserted table name)
								attrIdx = attrIdx + tableName.length() + 1 + appAttr[k].length();
							} else {
								// Must be a partial field match
								attrIdx = attrIdx + appAttr[k].length();
							}

						} else {
							attrIdx = attrIdx + appAttr[k].length();
						}
						// Search for next instance of the attribute
						attrIdx = whereFragment.toString().toLowerCase().indexOf(appAttr[k], attrIdx);				
					}
					splitWhere[i] = whereFragment.toString();
				}
				// Only process SQL; skip string literals
				i++;
			}
			// Recombine SQL and literals to reconstruct mroSelect
			whereBuffer = new StringBuffer("");
			for (k=0; k<splitWhere.length-1; k++) 
			{
				whereBuffer.append(splitWhere[k] + "'");
			}
			whereBuffer.append(splitWhere[splitWhere.length-1]);

			// Add subqueries back into mroSelect
			for (Enumeration enum = subquery.elements(); enum.hasMoreElements();) 
			{
				beginSub = whereBuffer.toString().indexOf(subPlaceholder);
				whereBuffer.replace(beginSub, beginSub+22, enum.nextElement().toString());
			}	

			// Remove buffer spaces at beginning and end of line
			whereBuffer.deleteCharAt(whereBuffer.length()-1);
			whereBuffer.deleteCharAt(0);

			mroSelect = whereBuffer.toString();
		}

	} catch (Exception ex) {
		// Unanticipated sql sytax; will default to original mroSelect
		System.out.println("runreport.jsp: Actuate Integration Error in selected records parsing: " + ex.getMessage());
	}
	
	try
	{
	
		if (!mroCurrent.equals("1=1"))
		{
			StringBuffer whereBuffer = new StringBuffer(" " + mroCurrent + " ");
			// Split where clause into array; alternate between SQL and string literals	
			StringTokenizer stWhere = new StringTokenizer(whereBuffer.toString(), "'");
			String[] splitWhere = new String[stWhere.countTokens()];
			i = 0;

			while (stWhere.hasMoreTokens()) {
				splitWhere[i++] = stWhere.nextToken();			
			}

			StringBuffer whereFragment;
			int attrIdx = -1;
			// For each segment of mroCurrent that is SQL (not literal), search for each attribute
			for(i=0; i<splitWhere.length; i++)
			{
				for(k=0; k<appAttr.length; k++)
				{
					whereFragment = new StringBuffer(splitWhere[i]);
					attrIdx = whereFragment.toString().toLowerCase().indexOf(appAttr[k]);

					while (attrIdx > -1) 
					{
						// Attribute has been found; determine if it is a valid field match 
						char priorChar = whereFragment.charAt(attrIdx-1);
						char nextChar = whereFragment.charAt(attrIdx + appAttr[k].length());

						// If preceeded by period, doesn't matter if this is our string or not
						// because this field is already qualified
						if (priorChar != '.') {
							if ((priorChar == ' ' || priorChar == '(') && (nextChar == ' ' || nextChar == '<' 
							|| nextChar == '>' || nextChar == '=' || nextChar == ')')) {
								// This is a valid match and is not qualified with the table name; insert it
								whereFragment.insert(attrIdx, tableName + ".");
								// Move index to after field name (adjust for inserted table name)
								attrIdx = attrIdx + tableName.length() + 1 + appAttr[k].length();
							} else {
								// Must be a partial field match
								attrIdx = attrIdx + appAttr[k].length();
							}

						} else {
							attrIdx = attrIdx + appAttr[k].length();
						}
						// Search for next instance of the attribute
						attrIdx = whereFragment.toString().toLowerCase().indexOf(appAttr[k], attrIdx);				
					}
					splitWhere[i] = whereFragment.toString();
				}
				// Only process SQL; skip string literals
				i++;
			}
			// Recombine SQL and literals to reconstruct mroCurrent
			whereBuffer = new StringBuffer("");
			for (k=0; k<splitWhere.length-1; k++) 
			{
				whereBuffer.append(splitWhere[k] + "'");
			}
			whereBuffer.append(splitWhere[splitWhere.length-1]);
			// Remove buffer spaces at beginning and end of line
			whereBuffer.deleteCharAt(whereBuffer.length()-1);
			whereBuffer.deleteCharAt(0);

			mroCurrent = whereBuffer.toString();
		}

	} catch (Exception ex) {
		// Unanticipated sql sytax; will default to original mroCurrent 
		System.out.println("runreport.jsp: Actuate Integration Error in current record parsing: " + ex.getMessage());
	}		
}

/* ************** Start of mroSelect Parsing to Insert Schema *********************************/

if (testForSelect.equals("true")) {
	try {
		i = 0;
		k = 0;
		// Convert all literal strings to dummy chars in case the word
		// from is used in a search string
		StringBuffer dummySelect = new StringBuffer(mroSelect);
		i = dummySelect.toString().indexOf("'");

		while (i > -1) {
			 
			k = dummySelect.toString().indexOf("'", ++i);
			while (i < k) {
				dummySelect.replace(i, ++i, "x");
			}

			 i = dummySelect.toString().indexOf("'", ++i);
		}

		// Create another copy of mroSelect to make actual updates against
		StringBuffer newSelect = new StringBuffer(mroSelect);

		i = dummySelect.toString().toLowerCase().indexOf(" from ");

		while (i > -1) {

			 i = i + 6;
			 // skip any white space between from and table name
			 char c = dummySelect.charAt(i);
			 while (Character.isWhitespace(c)) {
				 c = dummySelect.charAt(++i);
			 }

			// insert schema unless it is already present
			 if (!dummySelect.substring(i, i + schema.length() + 1).equalsIgnoreCase(schema + ".")) {
				 // insert schema into both dummy and actual selects so indexes remain the same
				 newSelect.insert(i, schema + ".");
				 dummySelect.insert(i, schema + ".");
			 }

			i = i + schema.length() + 1; 
			// Find the end of the table name - marked by comma or space
			c = dummySelect.charAt(i);
			while (!Character.isWhitespace(c) && (c != ',') && (i < dummySelect.length() - 1)) {
				c = dummySelect.charAt(++i);
			}
			
			// if the next non-whitespace character is a comma, there are more tables
			while (Character.isWhitespace(c) && (i < dummySelect.length() - 1)) {
				c = dummySelect.charAt(++i);
			}
			
			while (c == ',') {

				// move through whitespace to start of next table, then repeat steps above
				c = dummySelect.charAt(++i);
				while (Character.isWhitespace(c)) {
					c = dummySelect.charAt(++i);
				}
				
				if (!dummySelect.substring(i, i + schema.length() + 1).equalsIgnoreCase(schema + ".")) {
						 newSelect.insert(i, schema + ".");
						 dummySelect.insert(i, schema + ".");
				 }

				i = i + schema.length() + 1;				
				c = dummySelect.charAt(i);
				while (!Character.isWhitespace(c) && (c != ',') && (i < dummySelect.length() - 1)) {
					c = dummySelect.charAt(++i);
				}

				while (Character.isWhitespace(c) && (i < dummySelect.length() - 1)) {
					c = dummySelect.charAt(++i);
				}
		 	}

			 i = dummySelect.toString().toLowerCase().indexOf(" from ", i);
		}
		mroSelect = newSelect.toString();

	} catch (Exception ex) {
		mroSelect = (String)session.getValue("mroSelect");
	}
}
/* ************** End of mroSelect Parsing to Insert Schema *********************************/

%>
<form name="runReportForm" action="<%=reportURL%>" method="post" >
	<input type=hidden name="mroCurrent" value="">
	<input type=hidden name="mroSelect" value="">
	<input type=hidden name="mroApp" value="">
	<input type=hidden name="userName" value="">
	<input type=hidden name="password" value="">
	<input type=hidden name="reportServer" value="">
	<input type=hidden name="adminPass" value="">
	<input type=hidden name="smtpHost" value="">
	<input type=hidden name="mroSite" value="">
	<input type=hidden name="mroOrg" value="">
	<input type=hidden name="mroGroup" value="">
	<input type=hidden name="fromEmail" value="">
	<input type=hidden name="mroReport" value="">
	<input type=hidden name="mroRepName" value="">
	<input type=hidden name="locale" value="">
	<input type=hidden name="schema" value="">
	<input type=hidden name="connectString" value="">
	<input type=hidden name="pageType" value="">
	<input type=hidden name="localTZ" value="">
</form>
				
<SCRIPT LANGUAGE="JavaScript">
    var visitortime = new Date();
	var dateCount = 0;
	var i = 0;
	var dateIndex = 0;
	var strTime = visitortime.toString();
	for (i = 0; i < 4; i++) {
		dateIndex = strTime.indexOf(" ");
		var lenTime = strTime.length;
		strTime = strTime.substring(dateIndex+1, lenTime);
	}
	dateIndex = strTime.indexOf(" ");
	var lenTime = strTime.length;
	strTime = strTime.substring(0, dateIndex);
	dateIndex = strTime.indexOf("UTC");
	var lenTime = strTime.length;
	if (dateIndex > -1) {
		strTime = "GMT" + strTime.substring(dateIndex+3, lenTime);
	}
	if (strTime.indexOf("D") > -1) {
	   dateIndex = strTime.indexOf("D");
	   var lenTime = strTime.length;
	   strTime = strTime.substring(0, dateIndex) + "S" + strTime.substring(dateIndex+1, lenTime);
	}
	
function redirect()
{
	document.all.mroCurrent.value="<%=mroCurrent%>";
	document.all.mroSelect.value="<%=mroSelect%>";
	document.all.mroApp.value ="<%=mroApp%>";
	document.all.userName.value="<%=userName%>";
	document.all.password.value="<%=password%>";
	document.all.reportServer.value="<%=reportServer%>";
	document.all.adminPass.value="<%=adminPass%>";
	document.all.smtpHost.value="<%=smtpHost%>";
	document.all.mroSite.value="<%=mroSite%>";
	document.all.mroOrg.value="<%=mroOrg%>";
	document.all.mroGroup.value="<%=mroGroup%>";
	document.all.fromEmail.value="<%=fromEmail%>";
	document.all.mroReport.value="<%=mroReport%>";
	document.all.mroRepName.value="<%=mroRepName%>";
	document.all.locale.value="<%=locale%>";
	document.all.schema.value="<%=schema%>";
	document.all.connectString.value="<%=connectString%>";
	document.all.pageType.value="<%=pageType%>";
	document.all.localTZ.value=strTime;
	document.runReportForm.submit();
}
window.onload = redirect;
</SCRIPT>
